<?php
/*
Plugin Name: Plugins Enabler
Plugin URI: http://imath.owni.fr/2010/08/14/plugins-enabler/
Description: Works only for WordPress multisite. This plugin adds the ability to only show the plugins you enabled for a blog in your plugins menu.
Author: iMath
Version: 1.1
Author URI: http://imath.owni.fr
Network: true
*/

define ( 'PLUGINS_ENABLER_VERSION', '1.1' );
define ( 'PLUGINS_ENABLER_PLUGIN_NAME', 'plugins-enabler' );
define ( 'PLUGINS_ENABLER_URL', WP_PLUGIN_URL . '/' . PLUGINS_ENABLER_PLUGIN_NAME );
define ( 'PLUGINS_ENABLER_DIR', WP_PLUGIN_DIR . '/' . PLUGINS_ENABLER_PLUGIN_NAME );

wp_enqueue_script("jquery");
if($_GET['page']=="plugins-enabler"){
	wp_enqueue_script( 'sortable', PLUGINS_ENABLER_URL . '/js/jquery.tablesorter.min.js' );
}

load_plugin_textdomain(PLUGINS_ENABLER_PLUGIN_NAME, PLUGINS_ENABLER_DIR.'/languages/', PLUGINS_ENABLER_PLUGIN_NAME.'/languages/');


add_filter( 'all_plugins', 'plugins_enabler');
function plugins_enabler($plugins) {
	if (is_super_admin()) return $plugins;
	else return plugins_enabler_enabled($plugins);
}

/**
* plugins_enabler_list_blogs
* queries blog list
* 
*/
function plugins_enabler_list_blogs(){
	global $wpdb;
	$list = array();
	$list_blogs = $wpdb->get_col("SELECT blog_id FROM {$wpdb->base_prefix}blogs");
	foreach($list_blogs as $blog_id){
		$list[]=array("id"=>$blog_id,"blogname"=>get_blog_option( $blog_id, 'blogname' ), "blogurl"=>get_blog_option( $blog_id, 'siteurl'),"mail_admin"=>get_blog_option( $blog_id, 'admin_email' ));
	}
	return $list;
}

/**
* plugins_enabler_list_blogs_html
* displays blog list
* 
*/
function plugins_enabler_list_blogs_html(){
	$blogs = plugins_enabler_list_blogs();
	?>
	<style>
	table#blogTable .header{
		cursor:row-resize;
	}
	</style>
	<script type="text/javascript">
	function verif(){
		if(jQuery("input[type:radio]:checked").length == 0){
			alert("<?php _e('OOps, please choose 1 blog!','plugins-enabler');?>");
			return false;
		}
		return true;
	}
	jQuery(document).ready(function() 
	    { 
	        jQuery("#blogTable").tablesorter({ 
			        // pass the headers argument and assing a object 
			        headers: { 
			            // assign the secound column (we start counting zero) 
			            2: { 
			                // disable it by setting the property sorter to false 
			                sorter: false 
			            }, 
			            // assign the third column (we start counting zero) 
			            3: { 
			                // disable it by setting the property sorter to false 
			                sorter: false 
			            } 
			        } 
			    }); 
	    } 
	);
	</script>
	<p>
		<?php _e('Choose the blog you wish to manage his plugin list, then click on the &quot;Manage&quot; Button.','plugins-enabler');?>
	</p>
	<p>
		<form action="" method="POST" onsubmit="return verif()">
		<input type="submit" class="button-secondary" name="_manage_blogs_plugins" value="<?php _e('Manage','plugins-enabler');?>">
	</p>
	<table id="blogTable" class="widefat">
		<thead>
			<tr>
				<th><?php _e('Blog ID','plugins-enabler');?></th>
				<th><?php _e('Blog Name','plugins-enabler');?></th>
				<th><?php _e('Blog Url','plugins-enabler');?></th>
				<th><?php _e('Mail Admin','plugins-enabler');?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<th><?php _e('Blog ID','plugins-enabler');?></th>
				<th><?php _e('Blog Name','plugins-enabler');?></th>
				<th><?php _e('Blog Url','plugins-enabler');?></th>
				<th><?php _e('Mail Admin','plugins-enabler');?></th>
			</tr>
		</tfoot>
		<tbody>
	<?php for($i=1;$i<count($blogs);$i++):?>
			<tr>
				<td><input type="radio" name="_blog_id" value="<?php echo $blogs[$i]['id'];?>"/><?php echo $blogs[$i]['id'];?></td>
				<td><?php echo $blogs[$i]['blogname'];?></td>
				<td><?php echo $blogs[$i]['blogurl'];?></td>
				<td><?php echo $blogs[$i]['mail_admin'];?></td>
			</tr>
	<?php endfor;?>
		</tbody>
	</table>
	<p>
		<input type="submit" class="button-secondary" name="_manage_blogs_plugins" value="<?php _e('Manage','plugins-enabler');?>">
	</p>
	<?php
}

/**
* plugins_enabler_manage_single
* choosing enabled plugins for a blog..
* 
*/
function plugins_enabler_manage_single($blog_id){
	$plugins = plugins_enabler_no_network();
	$list_plugins = plugins_enabler_get_enabled($blog_id);
	$infos_blog = get_blog_details($blog_id);
	?>
	<script type="text/javascript">
	<?php if($list_plugins):?>
		<?php 
		foreach($list_plugins as $plugin){
			@$jstable.= '"'.$plugin.'",';
		}
		$jstable = substr($jstable, 0, strlen($jstable)-1);
		;?>
	list_plugins = new Array(<?php echo $jstable;?>);
	jQuery(document).ready(function() {
		jQuery("#enabled-plugins input[type=checkbox]").each(function(){
			if(is_plugin_allready_ok(list_plugins, this.value)!=-1) this.checked=true;
		}
		);
	});
	<?php endif;?>
	function is_plugin_allready_ok(array_listing, searched){
		position=-1;
		for(i=0;i<array_listing.length;i++){
			if(array_listing[i]==searched) position = i;
		}
		return position;
	}
	</script>
	<style type="text/css">
	#enabled-plugins th, #enabled-plugins td {background-color:none !important;}
	#enabled-plugins .row-actions-visible ,#enabled-plugins .plugin-update-tr  {display: none;}
	</style>
	<p>
		<?php printf( __( 'Managing plugins for <b>%s blog</b>', 'plugins-enabler' ), $infos_blog->blogname ) ;?>
		(<i><a href="<?php echo $infos_blog->siteurl;?>" target="_blank" title="<?php _e('Open in a new window','plugins-enabler');?>"><?php echo $infos_blog->domain.$infos_blog->path;?></a></i>)
	</p>
		<form action="" method="POST">
			<input type="hidden" value="<?php echo $blog_id;?>" name="_managed_blog_id"/>
			<p>
				<input type="submit" class="button-secondary" name="_enable_checked_plugins" value="<?php _e('Enable checked plugins','plugins-enabler');?>">&nbsp;&nbsp;<a href="plugins.php?page=plugins-enabler" class="button-secondary"><?php _e('Back to blog list','plugins-enabler');?></a>
			</p>
			<div id="enabled-plugins">
				<?php plugins_enabler_print_plugins_table($plugins); ?>
			</div>
			<p>
				<input type="submit" class="button-secondary" name="_enable_checked_plugins" value="<?php _e('Enable checked plugins','plugins-enabler');?>">&nbsp;&nbsp;<a href="plugins.php?page=plugins-enabler" class="button-secondary"><?php _e('Back to blog list','plugins-enabler');?></a>
			</p>
			<?php wp_nonce_field( '_plugins_enabler' );?>
		</form>
	<?php
}

/**
* plugins_enbler_enable_plugins
* storing data in db..
* 
*/
function plugins_enbler_enable_plugins($postvars){
	global $wpdb;
	$infos_blog = get_blog_details($postvars['_managed_blog_id']);
	$is_update = plugins_enabler_check_for_update($postvars['_managed_blog_id']);
	$plugins_enabled = maybe_serialize($postvars["checked"]);
	$result = 0;
	$type = "";
	if(check_admin_referer('_plugins_enabler')){
		if($is_update){
			$update_plugins_list = $wpdb->update($wpdb->base_prefix.'plugins_enabler', array('enabled_value' => $plugins_enabled), array('blog_id'=>$postvars['_managed_blog_id']));
			$result = $update_plugins_list;
			$type = "update";
		}
		else{
			$insert_plugins_list = $wpdb->insert($wpdb->base_prefix.'plugins_enabler', array('blog_id' => $postvars['_managed_blog_id'], 'enabled_value' => $plugins_enabled));
			$result = $insert_plugins_list;
			$type = "insert";
		}
		if($type=="update" && $result>=0 || $type=="insert" && $result>0){
			?>
			<div id="message" class="updated fade"><p><?php printf( __( 'Plugins list updated for %s blog', 'plugins-enabler' ), $infos_blog->blogname ) ;?></p></div>
			<?php
		}else{
			?>
			<div id="message" class="error fade"><p><?php _e( 'OOps something went wrong, Please try again.', 'plugins-enabler' );?></p></div>
			<?php
		}
	}
	plugins_enabler_list_blogs_html();
}


/**
* plugins_enabler_list_plugins
* displays the plugins list
* 
*/
function plugins_enabler_list_plugins(){
	$plugins = get_plugins();
	?>
	<?php print_plugins_table($plugins); ?>
	<?php
}

/**
* plugins_enabler_enabled
* returns an array of enabled plugins + others for a blog id
* 
*/
function plugins_enabler_enabled($plugins){
	global $blog_id;
	$enabled_plugins = array();
	$enabling = plugins_enabler_get_enabled($blog_id);
	if ($enabling){
		foreach ( (array) $plugins as $plugin => $plugin_data) {
			if (in_array($plugin,$enabling)){$enabled_plugins[$plugin]=$plugin_data;}
		}
	}
	return $enabled_plugins;
}


/**
* plugins_enabler_get_enabled
* returns an array of enabled plugins for a blog id
* 
*/
function plugins_enabler_get_enabled($blogid){
	global $wpdb;
	$plugins_enabled = $wpdb->get_var( "SELECT enabled_value FROM {$wpdb->base_prefix}plugins_enabler where blog_id='$blogid'" );
	return maybe_unserialize($plugins_enabled);
}

/**
* plugins_enabler_check_for_update
* check in DB if there's allready a blog id..
* 
*/
function plugins_enabler_check_for_update($blogid){
	global $wpdb;
	$plugins_enabled = $wpdb->get_var( "SELECT blog_id FROM {$wpdb->base_prefix}plugins_enabler where blog_id='$blogid'" );
	return $plugins_enabled;
}


/**
* plugins_enabler_no_network
* exclude network only plugins
* 
*/
function plugins_enabler_no_network(){
	$plugins = get_plugins();
	$network_plugins = array();
	foreach ( (array) $plugins as $plugin => $plugin_data) {
		if ( is_network_only_plugin($plugin)) {
			$network_plugins[$plugin] = $plugin_data;
		}
	}
	return array_diff_assoc($plugins, $network_plugins);
}


// Hook for adding admin menus
add_action( plugins_enabler_is_django_multisite() ? 'network_admin_menu' : 'admin_menu', 'plugins_enabler_admin' );

// action function for above hook
function plugins_enabler_admin() {
	if (is_multisite()){
		 if (is_super_admin()){
			add_plugins_page('Plugins Enabler Manager', 'Plugins Enabler Manager', 'manage_options', 'plugins-enabler', 'plugins_enabler_manager');
		}
	}else{
		add_plugins_page('Plugins Enabler Manager', 'Plugins Enabler Manager', 'manage_options', 'plugins-enabler', 'plugins_enabler_manager_multi_off');
	}
}

/**
* plugins_enabler_manager
* main function to choose the blog and select its available plugins..
* 
*/
function plugins_enabler_manager(){
	global $blog_id;
	if (!is_super_admin())  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}else{
	?>
	<div class="wrap">
		<h2>Plugins Enabler</h2>
		<?php if(!$_POST):?>
			<?php plugins_enabler_list_blogs_html();?>
		<?php elseif($_POST['_manage_blogs_plugins']):?>
			<?php plugins_enabler_manage_single($_POST['_blog_id'])?>
		<?php else:?>
			<?php plugins_enbler_enable_plugins($_POST);?>
		<?php endif;?>
	</div>
	<?php
	}
}

/**
* plugins_enabler_manager_multi_off
* OOps only work for a network ;)
* 
*/
function plugins_enabler_manager_multi_off(){
	?>
	<div class="wrap">
		<h2>Plugins Enabler</h2>
		<p><?php _e('OOps, this plugin requires that you activate the network tool of WordPress','plugins-enabler');?>
	</div>
	<?php
}

function plugins_enabler_is_django_multisite(){
	if(get_option('db_version')>=17056 && is_multisite()) return true;
	else return false;
}


function plugins_enabler_print_plugins_table($plugins, $context = '') {
	$checkbox = ! in_array( $context, array( 'mustuse', 'dropins' ) ) ? '<input type="checkbox" />' : '';
?>
<table class="widefat" cellspacing="0" id="<?php echo $context ?>-plugins-table">
<thead>
<tr>
	<th scope="col" class="manage-column check-column"><?php echo $checkbox; ?></th>
	<th scope="col" class="manage-column"><?php _e('Plugin','plugins-enabler'); ?></th>
	<th scope="col" class="manage-column"><?php _e('Description','plugins-enabler'); ?></th>
</tr>
</thead>

<tfoot>
<tr>
	<th scope="col" class="manage-column check-column"><?php echo $checkbox; ?></th>
	<th scope="col" class="manage-column"><?php _e('Plugin','plugins-enabler'); ?></th>
	<th scope="col" class="manage-column"><?php _e('Description','plugins-enabler'); ?></th>
</tr>
</tfoot>

<tbody class="plugins">
<?php

	if ( empty($plugins) ) {
		echo '<tr>
			<td colspan="3">' . __('No plugins to show','plugins-enabler') . '</td>
		</tr>';
	}
	foreach ( (array)$plugins as $plugin_file => $plugin_data) {

		$checkbox = "<input type='checkbox' name='checked[]' value='" . esc_attr($plugin_file) . "' />";
		$description = '<p>' . $plugin_data['Description'] . '</p>';
		$plugin_name = $plugin_data['Name'];

		echo "
<tr class='$class'>
	<th scope='row' class='check-column'>$checkbox</th>
	<td class='plugin-title'><strong>$plugin_name</strong></td>
	<td class='desc'>$description</td>
</tr>
<tr class='$class second'>
	<td></td>
	<td class='plugin-title'>";
		echo '<div class="row-actions-visible"></div></td><td class="desc">';
		$plugin_meta = array();
		if ( !empty($plugin_data['Version']) )
			$plugin_meta[] = sprintf(__('Version %s','plugins-enabler'), $plugin_data['Version']);
		if ( !empty($plugin_data['Author']) ) {
			$author = $plugin_data['Author'];
			if ( !empty($plugin_data['AuthorURI']) )
				$author = '<a href="' . $plugin_data['AuthorURI'] . '" title="' . __( 'Visit author homepage','plugins-enabler' ) . '">' . $plugin_data['Author'] . '</a>';
			$plugin_meta[] = sprintf( __('By %s','plugins-enabler'), $author );
		}
		if ( ! empty($plugin_data['PluginURI']) )
			$plugin_meta[] = '<a href="' . $plugin_data['PluginURI'] . '" title="' . __( 'Visit plugin site','plugins-enabler' ) . '">' . __('Visit plugin site','plugins-enabler') . '</a>';

		$plugin_meta = apply_filters('plugin_row_meta', $plugin_meta, $plugin_file, $plugin_data, $context);
		echo implode(' | ', $plugin_meta);
		echo "</td>
</tr>\n";
	}
?>
</tbody>
</table>
<?php
}

/**
* plugins_enabler_activate
* Installs DBs and set default options
* 
*/
function plugins_enabler_activate() {
	global $wpdb;

	if ( !empty($wpdb->charset) )
		$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";

	$sql[] = "CREATE TABLE {$wpdb->base_prefix}plugins_enabler (
	          blog_id bigint(20) NOT NULL PRIMARY KEY,
	  		  enabled_value longtext COLLATE utf8_unicode_ci NOT NULL
	          ){$charset_collate};";
	

	require_once( ABSPATH . 'wp-admin/upgrade-functions.php' );
	
	//if first install
	if(!get_option('plugins-enabler-version')){
		dbDelta($sql);
		update_option( 'plugins-enabler-version', PLUGINS_ENABLER_VERSION );
	}
	else update_option( 'plugins-enabler-version', PLUGINS_ENABLER_VERSION );
}
register_activation_hook( __FILE__, 'plugins_enabler_activate' );
?>